UNIT mTEreignisAnwendung;

interface

uses           mSuM, mUhr, mTKreisknopf, mTRechteckKnopf, mTMuehle,
          Dialogs;
// Uses-Klausel ggf. anpassen

type
   TEreignisAnwendung = CLASS

     // weitere Attribute
     private
        zMausUnten : Wahrheitswert;
     protected
         derBildschirm : Bildschirm;
         dieMaus : Maus;
         hatStift : Stift;
         dieTastatur : Tastatur;
         KEnde : TRechteckknopf;
         zBeenden : Wahrheitswert;

     // weitere Methoden
     private
        procedure bearbeiteMausDoppelklick;
        procedure bearbeiteMausLosgelassen;
        procedure bearbeiteMausUnten;
     public
        constructor init; virtual;
        procedure bearbeiteLeerlauf; virtual; abstract;
        procedure beenden;
        procedure run;
        destructor gibFrei; virtual;

   end;

implementation

//+---------------------------------------------------------------------
//|         TEreignisAnwendung: Methodendefinition 
//+---------------------------------------------------------------------

//-------- bearbeiteMausDoppelklick (private) --------------------------
procedure TEreignisAnwendung.bearbeiteMausDoppelklick;
begin
    KEnde.bearbeiteMausDoppelklick(dieMaus.hPosition, dieMaus.vPosition)
end;

//-------- bearbeiteMausLosgelassen (private) --------------------------
procedure TEreignisAnwendung.bearbeiteMausLosgelassen;
begin
    KEnde.bearbeiteMausLosgelassen(dieMaus.hPosition, dieMaus.vPosition)
end;

//-------- bearbeiteMausUnten (private) --------------------------------
procedure TEreignisAnwendung.bearbeiteMausUnten;
begin
    KEnde.bearbeiteMausUnten(dieMaus.hPosition, dieMaus.vPosition)
end;

//-------- init (public) -----------------------------------------------
constructor TEreignisAnwendung.init;
begin
  derBildschirm := Bildschirm.init;
  dieMaus       := Maus.init;
  hatStift      := Stift.init;
  dieTastatur   := Tastatur.init;
  KEnde         := TRechteckknopf.init(310,450,80,'ENDE',dieMaus);
  KEnde.aktiviere;
end;

//-------- beenden (public) --------------------------------------------
procedure TEreignisAnwendung.beenden;
begin
  zBeenden := true
end;

//-------- run (public) ------------------------------------------------
procedure TEreignisAnwendung.run;
begin
  zBeenden := false;
  zMausUnten := false;
  repeat
     // bei dieser Ereignisschleife knnen alle drei
     // Ereignisse abgefragt werden.
     // Bei Doppelklick wird allerdings erst das Mauslosgelassen
     // vom ersten Klick des Doppelklick ausgefhrt.
      if dieMaus.istGedrueckt then
           begin
              zMausUnten := Wahr;
              bearbeiteMausUnten;
           end
      else
           begin //maus ist nicht gedrckt
              if dieMaus.doppelklick
                 then
                    bearbeiteMausDoppelklick
                 else
                    if zMausUnten
                       then bearbeiteMausLosgelassen;
              zMausUnten := falsch;
           end; //of Maus ist nicht gedrckt
      bearbeiteLeerlauf
   until zBeenden;
end;

//-------- gibFrei (public) --------------------------------------------
destructor TEreignisAnwendung.gibFrei;
begin
  dieTastatur.gibFrei;
  hatStift.GibFrei;
  dieMaus.gibFrei;
  derBildschirm.gibFrei
end;

end.
