UNIT mTEreignisKnopf;

interface

uses                 mSuM, Dialogs;
// Uses-Klausel ggf. anpassen

type
   TEreignisKnopf = CLASS

     // weitere Attribute
     private
        kenntNaechstenKnopf : TEreignisknopf;
     protected
         hatStift : BuntStift;
         zFarbe : ganzeZahl;
         zAktiv : Wahrheitswert;
         zMausWarOben : Wahrheitswert;
         zWurdeGedrueckt : Wahrheitswert;
         zGroesse : Zahl;
         zXPos : Zahl;
         zYPos : Zahl;
         zAufschrift : Zeichenkette;

     // weitere Methoden
     private
        procedure anzeige(pZuZeigen:Zeichenkette; pX,pY:Zahl);
        procedure setzeFarbe(pFarbe:ganzeZahl);
     public
        constructor init(pX,pY,pGroesse:Zahl; pAufschrift:Zeichenkette; pMaus:Maus);
        procedure aktiviere;
        procedure bearbeiteMausDoppelKlick(pX,pY:Zahl);
        procedure bearbeiteMausLosgelassen(pX,pY:Zahl);
        procedure bearbeiteMausUnten(pX,pY:Zahl);
        procedure deaktiviere;
        procedure haengeAn(pKnopf:TEreignisKnopf);
        procedure loesche; virtual; abstract;
        procedure zeichne; virtual; abstract;
        function innerhalb(pX,pY:Zahl) : Wahrheitswert; virtual; abstract;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TEreignisKnopf: Methodendefinition 
//+---------------------------------------------------------------------

//-------- anzeige (private) -------------------------------------------
procedure TEreignisKnopf.anzeige(pZuZeigen:Zeichenkette; pX,pY:Zahl);
begin
   hatStift.bewegeBis(pX,pY);
   hatStift.schreibeText('                                                   ');
   hatStift.bewegeBis(pX,pY);
   hatStift.schreibeText(pZuZeigen);
end;

//-------- setzeFarbe (private) ----------------------------------------
procedure TEreignisKnopf.setzeFarbe(pFarbe:ganzeZahl);
begin
   if zFarbe <> pfarbe then
      begin
         loesche;
         zFarbe := pFarbe;
         zeichne
      end
end;

//-------- init (public) -----------------------------------------------
constructor TEreignisKnopf.init(pX,pY,pGroesse:Zahl; pAufschrift:Zeichenkette; pMaus:Maus);
begin
  zXpos := pX;
  zYPos := py;
  zGroesse := pGroesse;
  zAufschrift := pAufschrift;
  hatStift := BuntStift.init;
  zWurdeGedrueckt := Falsch;
  zMausWarOben := Wahr;
  zAktiv := falsch;
  kenntNaechstenKnopf := nil;
  zeichne
end;

//-------- aktiviere (public) ------------------------------------------
procedure TEreignisKnopf.aktiviere;
begin
  if not zAktiv then
     begin
        loesche;
        zAktiv := Wahr;
        zeichne
     end
end;

//-------- bearbeiteMausDoppelKlick (public) ---------------------------
procedure TEreignisKnopf.bearbeiteMausDoppelKlick(pX,pY:Zahl);
begin
if zAktiv then
      begin
         if innerhalb(pX,pY) then
            begin
               anzeige('Doppelklick : '+self.zAufschrift,600,300);
            end;
         loesche;
         zWurdeGedrueckt := Falsch;
         zMausWarOben := Wahr;
         zeichne;
         anzeige('Gedrueckt : ---',600,100)
      end;
   if kenntNaechstenKnopf <> nil
     then kenntNaechstenKnopf.bearbeiteMausDoppelklick(pX,pY)
end;

//-------- bearbeiteMausLosgelassen (public) ---------------------------
procedure TEreignisKnopf.bearbeiteMausLosgelassen(pX,pY:Zahl);
begin
   if zAktiv then
      begin
         if zWurdeGedrueckt then
            begin
               loesche;
               zWurdeGedrueckt := Falsch;
               zeichne;
               if innerhalb(pX,pY) then
                  begin
                     anzeige('Angeklickt : '+zAufschrift,600,200) ;
                  end
            end
         else
            begin
               zWurdeGedrueckt := Falsch
            end ;
         zMausWarOben := Wahr;
         anzeige('Gedrueckt : ---',600,100)
      end;// of aktiv
   if kenntNaechstenKnopf <> nil
     then kenntNaechstenKnopf.bearbeiteMausLosgelassen(pX,pY)
end;

//-------- bearbeiteMausUnten (public) ---------------------------------
procedure TEreignisKnopf.bearbeiteMausUnten(pX,pY:Zahl);
begin
   if zAktiv then
      begin
         if zWurdeGedrueckt then
            begin
               if innerhalb (pX,pY) then
                  begin // weiterhin innerhalb gedrckt
                     anzeige('Gedrueckt : '+zAufschrift,600,100)
                     // hier muss eine Aktion ausgefhrt werden
                  end
               else
                  begin // gedrueckt herausgezogen
                     loesche;
                     zWurdeGedrueckt := Falsch;
                     zeichne;
                     anzeige('Gedrueckt : ---',600,100)
                  end
            end //of War vorher gedrueckt
         else
            begin // war nicht gedrckt
               if innerhalb (pX, pY) and zMausWarOben then
                  begin // neue gedrckt oder hineingezogen
                     loesche;
                     zWurdeGedrueckt := Wahr;
                     zeichne;
                     anzeige('Gedrueckt : '+zAufschrift,600,100)
                     // hier muss eine Aktion ausgefhrt werden
                  end
               else
                  begin // nicht gedrckt
                     // es ndert sich nicht
                  end
            end; // of war nicht gedrckt
         zMausWarOben := Falsch;
      end;
   if kenntNaechstenKnopf <> nil
     then kenntNaechstenKnopf.bearbeiteMausUnten(pX,pY)
end;

//-------- deaktiviere (public) ----------------------------------------
procedure TEreignisKnopf.deaktiviere;
begin
  if zAktiv then
     begin
        loesche;
        zAktiv := Falsch;
        zeichne
     end
end;

//-------- haengeAn (public) -------------------------------------------
procedure TEreignisKnopf.haengeAn(pKnopf:TEreignisKnopf);
begin
   if kenntNaechstenKnopf = nil then
      begin
         kenntNaechstenKnopf := pKnopf
      end
   else
      begin
         kenntNaechstenKnopf.haengeAn(pKnopf)
      end
end;

//-------- gibFrei (public) --------------------------------------------
destructor TEreignisKnopf.gibFrei;
begin
  loesche;
end;

end.
