UNIT mTKnopf;

interface

uses         mSuM;
// Uses-Klausel ggf. anpassen

type
   TKnopf = CLASS

     // weitere Attribute
     protected
         hatStift : BuntStift;
         zFarbe : ganzeZahl;
         kenntMaus : Maus;
         zAktiv : Wahrheitswert;
         zMausUnten : Wahrheitswert;
         zGroesse : Zahl;
         zXPos : Zahl;
         zYPos : Zahl;
         zAufschrift : Zeichenkette;

     // weitere Methoden
     public
        constructor init(pX,pY,pGroesse:Zahl; pAufschrift:Zeichenkette; pMaus:Maus);
        procedure aktiviere;
        procedure deaktiviere;
        procedure loesche; virtual; abstract;
        procedure setzeFarbe(pFarbe:ganzeZahl);
        procedure zeichne; virtual; abstract;
        function angeklickt : Wahrheitswert;
        function doppelklick : Wahrheitswert;
        function gedrueckt : Wahrheitswert;
        function innerhalb : Wahrheitswert; virtual; abstract;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TKnopf: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TKnopf.init(pX,pY,pGroesse:Zahl; pAufschrift:Zeichenkette; pMaus:Maus);
begin
  zXpos := pX;
  zYPos := py;
  zGroesse := pGroesse;
  zAufschrift := pAufschrift;
  kenntMaus := pMaus;
  hatStift := BuntStift.init;
  zMausUNten := falsch;
  zAktiv := falsch;
  zeichne
end;

//-------- aktiviere (public) ------------------------------------------
procedure TKnopf.aktiviere;
begin
  if not zAktiv then
     begin
        loesche;
        zAktiv := Wahr;
        zeichne
     end
end;

//-------- deaktiviere (public) ----------------------------------------
procedure TKnopf.deaktiviere;
begin
  if ZAktiv then
     begin
        loesche;
        zAktiv := Falsch;
        zeichne
     end   
end;

//-------- setzeFarbe (public) -----------------------------------------
procedure TKnopf.setzeFarbe(pFarbe:ganzeZahl);
begin
   if zFarbe <> pfarbe then
      begin
         loesche;
         zFarbe := pFarbe;
         zeichne
      end
end;

//-------- angeklickt (public) -----------------------------------------
function TKnopf.angeklickt : Wahrheitswert;
begin
  if zAktiv then
     begin
        if zMausUnten then
           if not innerhalb
           then // Maus ausserhalb des Knopfes
              begin
                 loesche;
                 zMausUnten := False;
                 zeichne;
                 result := false;
              end
           else // Maus innerhalb des Knopfes
              begin
                 if kenntMaus.istgedrueckt
                    then
                        result := false
                    else
                       begin
                          loesche;
                          zMausUnten := False;
                          zeichne;
                          result := Wahr;
                       end
              end //of Maus innerhalb des Knopfes
        else // Maus vorher nicht unten
           begin
              result := Falsch;
              if kenntMaus.istgedrueckt and
                 innerhalb
              then
                 begin
                    loesche;
                    zMausUnten := Wahr;
                    zeichne
                 end
            end //of Maus vorher nicht unten
      end //of Aktiv
   else
      result := false
end;

//-------- doppelklick (public) ----------------------------------------
function TKnopf.doppelklick : Wahrheitswert;
begin
   if zAktiv then
      begin
         if  innerhalb
             then result := true
             else result := false;
         loesche;
         zMausUnten := falsch;
         zeichne
      end
   else //nicht aktiv
      result := false
end;

//-------- gedrueckt (public) ------------------------------------------
function TKnopf.gedrueckt : Wahrheitswert;
begin
   if zAktiv then
      begin
        if zMausUnten then
           if not innerhalb
           then // Maus ausserhalb des Knopfes
              begin
                 loesche;
                 zMausUnten := Falsch;
                 zeichne;
                 result := Falsch;
              end
           else // Maus innerhalb des Knopfes
              begin
                 if kenntMaus.istgedrueckt
                    then
                        result := Wahr
                    else
                       begin
                          loesche;
                          zMausUnten := Falsch;
                          zeichne ;
                          result := Falsch;
                       end

              end //of Maus innerhalb des Knopfes
        else // Maus vorher nicht unten
           begin
              if kenntMaus.istgedrueckt and
                 innerhalb
              then
                 begin
                     loesche;
                     zMausUnten := Wahr;
                     zeichne;
                     result := wahr;
                 end
              else
                 begin
                    result := falsch
                 end
            end
      end //of zAktiv
   else
      result := false   
end;

//-------- gibFrei (public) --------------------------------------------
destructor TKnopf.gibFrei;
begin
  loesche
end;

end.
