UNIT mTKreisknopf;

interface

uses           mSuM,mTEreignisKnopf;
// Uses-Klausel ggf. anpassen

type
   TKreisknopf = CLASS(TEreignisKnopf)

     // weitere Methoden
     public
        procedure loesche; override;
        procedure zeichne; override;
        function innerhalb(pX,pY:Zahl) : Wahrheitswert; override;

   end;

implementation

//+---------------------------------------------------------------------
//|         TKreisknopf: Methodendefinition 
//+---------------------------------------------------------------------

//-------- loesche (public) --------------------------------------------
procedure TKreisknopf.loesche;
begin
   hatStift.setzefarbe(weiss);
   hatStift.setzeFuellMuster(gefuellt);
   hatStift.setzeLinienbreite(3);
  hatStift.bewegeBis(zXPos,zYPos);
   hatStift.zeichneKreis(zGroesse);
end;

//-------- zeichne (public) --------------------------------------------
procedure TKreisknopf.zeichne;
var lokalSchriftbreite : ganzeZahl;
begin
  hatStift.bewegeBis(zXPos,zYPos);
  hatStift.setzeLinienbreite(1);
  if zAktiv
     then
        hatStift.setzeFarbe(hellgruen)
     else
        hatStift.setzefarbe(hellgrau);
  hatStift.setzeFuellMuster(gefuellt);
  hatStift.zeichneKreis(zGroesse-1);
  hatStift.setzeFarbe(schwarz);
  hatStift.setzeFuellMuster(durchsichtig);
  if zAktiv then
    begin
      if zWurdeGedrueckt then
         hatStift.setzeLinienbreite(3)
      else
         hatStift.setzeLinienBreite(2);
    end
  else
    begin
      hatStift.setzeLinienbreite(1)
    end;  
  hatStift.zeichneKreis(zGroesse);

  if zAktiv
     then
       begin
         hatStift.setzeSchriftStil(fett);
         hatStift.setzeFarbe(schwarz);
       end
     else
       begin
         hatStift.setzeSchriftstil(standardstil);
         hatStift.setzeFarbe(dunkelgrau)
       end;
  hatStift.setzeSchriftgroesse(14);
  lokalSchriftbreite := hatStift.TextBreite(zAufschrift);
  hatStift.bewegeBis(zXPos-lokalSchriftbreite/2,zYPos-6);

  hatStift.schreibeText(zAufschrift);
end;

//-------- innerhalb (public) ------------------------------------------
function TKreisknopf.innerhalb(pX,pY:Zahl) : Wahrheitswert;
begin
   result :=  (sqrt(sqr(pX-zXpos) + sqr(pY-zYpos))
                       <= zGroesse )
end;

end.
