UNIT mTMuehle;

interface

uses          mSuM;
// Uses-Klausel ggf. anpassen

type
   TMuehle = CLASS

     // weitere Attribute
     private
        kenntNaechsteMuhle : TMuehle;
     protected
         hatStift : BuntStift;
         zFarbe : GanzeZahl;
         kenntMaus : Maus;
         zGeschwindigkeit : Zahl;
         zGroesse : Zahl;
         zRichtung : Zahl;
         zXPos : Zahl;
         zYPos : Zahl;

     // weitere Methoden
     public
        constructor init(pX,pY,pGroesse,pGeschwindigkeit:Zahl; pFarbe:ganzeZahl);
        procedure drehe;
        procedure haengeAn(pMuehle:TMuehle);
        procedure langsamer;
        procedure loesche;
        procedure schneller;
        procedure setzeGeschwindigkeit(pGeschwindigkeit:Zahl);
        procedure setzeZufallsfarbe;
        procedure stop;
        procedure zeichne;
        function Geschwindigkeit : Zahl;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TMuehle: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TMuehle.init(pX,pY,pGroesse,pGeschwindigkeit:Zahl; pFarbe:ganzeZahl);
begin
  zXpos := pX;
  zYPos := py;
  zGroesse := pGroesse;
  zGeschwindigkeit := pGeschwindigkeit;
  zRichtung := random(180);
  zFarbe := pFarbe;
  hatStift := BuntStift.init;
  hatStift.wechsle;
  kenntNaechsteMuhle := nil;
  zeichne
end;

//-------- drehe (public) ----------------------------------------------
procedure TMuehle.drehe;
begin
   loesche;
   zRichtung := zRichtung + zGeschwindigkeit;
   zeichne;
   if kenntNaechsteMuhle <> nil then
     kenntNaechsteMuhle.drehe;
end;

//-------- haengeAn (public) -------------------------------------------
procedure TMuehle.haengeAn(pMuehle:TMuehle);
begin
  if kenntNaechsteMuhle = nil then begin
     kenntNaechsteMuhle := pMuehle;
  end
  else begin

     kenntNaechsteMuhle.haengeAn(pMuehle);
  end
end ;

//-------- langsamer (public) ------------------------------------------
procedure TMuehle.langsamer;
begin
  if zGeschwindigkeit > 0.1 then zGeschwindigkeit := zGeschwindigkeit - 0.01;
  if kenntNaechsteMuhle <> nil then
     kenntNaechsteMuhle.langsamer;
end;

//-------- loesche (public) --------------------------------------------
procedure TMuehle.loesche;
begin
  zeichne;
end;

//-------- schneller (public) ------------------------------------------
procedure TMuehle.schneller;
begin
  zGeschwindigkeit := zGeschwindigkeit + 0.01;
  if kenntNaechsteMuhle <> nil then
     kenntNaechsteMuhle.schneller;
end;

//-------- setzeGeschwindigkeit (public) -------------------------------
procedure TMuehle.setzeGeschwindigkeit(pGeschwindigkeit:Zahl);
begin
   zGeschwindigkeit := pGeschwindigkeit;
   if kenntNaechsteMuhle <> nil then
     kenntNaechsteMuhle.setzeGeschwindigkeit(pGeschwindigkeit)
end;

//-------- setzeZufallsfarbe (public) ----------------------------------
procedure TMuehle.setzeZufallsfarbe;
var lZufall : GanzeZahl;
begin
   zeichne;
   lZufall := 1+ random(15);
   case lZufall of
     1 :  zFarbe := ROT;
     2 :  zFarbe := BRAUN;
     3 :  zFarbe := MAGENTA;
     4 :  zFarbe := SCHWARZ;
     5 :  zFarbe := DUNKELGRAU;
     6 :  zFarbe := GRAU;
     7 :  zFarbe := HELLGRAU;
     8 :  zFarbe := BLAU;
     9 :  zFarbe := DUNKELBLAU;
     10 :  zFarbe := HELLBLAU;
     11 :  zFarbe := GRUEN;
     12 :  zFarbe := HELLGRUEN;
     13 :  zFarbe := DUNKELGRUEN;
     14 :  zFarbe := GELB;
     15 :  zFarbe := ORANGE;
   end;
   zeichne  
end;

//-------- stop (public) -----------------------------------------------
procedure TMuehle.stop;
begin
  zGeschwindigkeit := 0;
  if kenntNaechsteMuhle <> nil then
     kenntNaechsteMuhle.stop;
end;

//-------- zeichne (public) --------------------------------------------
procedure TMuehle.zeichne;
var i : GanzeZahl;
begin
  hatStift.setzeFarbe(zFarbe);
  hatStift.hoch;
  hatStift.bewegeBis(zXpos,zYPos);
  hatStift.setzeLinienBreite(4);
  hatStift.runter;
  hatStift.bewegeBis(zXpos,zYpos-zGroesse);
  hatStift.dreheBis(zRichtung);
  hatStift.setzeLinienBreite(2);
  hatStift.bewegeUm(zGroesse/2);
  hatStift.dreheUm(180);
  hatStift.hoch;
  hatStift.bewegeUm(zGroesse/2);
  hatStift.runter;
  hatStift.bewegeUm(zGroesse/2);
  hatStift.hoch ;
end;

//-------- Geschwindigkeit (public) ------------------------------------
function TMuehle.Geschwindigkeit : Zahl;
begin
  result := zGeschwindigkeit
end;

//-------- gibFrei (public) --------------------------------------------
destructor TMuehle.gibFrei;
begin
  loesche;
  if kenntNaechsteMuhle <> nil then
     kenntNaechsteMuhle.GibFrei;
end;

end.
