UNIT mTMuehlenAnwendung;

interface

uses          mSuM, mTEreignisAnwendung, mUhr, mTKreisknopf, mTRechteckKnopf, mTMuehle;
// Uses-Klausel ggf. anpassen

type
   TMuehlenAnwendung = CLASS(TEreignisAnwendung)

     // weitere Attribute
     private
        KLangsamer : TKreisknopf;
        KSchneller : TKreisknopf;
        KStop : TKreisknopf;
        Muehle1 : TMuehle;
        neueMuehle : TMuehle;
        KneueMuehle : TRechteckknopf;
        dieUhr : Uhr;

     //Objektbeziehungen:
        // hatTKreisknopf ( ) of TKreisknopf;
        // hatTKreisknopf () of TKreisknopf;
        // hatTKreisknopf1, // hatTKreisknopf2, // hatTKreisknopf3 : TKreisknopf;
        // hatTRechteckKnopf1, // hatTRechteckKnopf2 : TRechteckKnopf;
        // hatTRechteckKnopf () of TRechteckKnopf;

     // weitere Methoden
     public
        constructor init; override;
        procedure bearbeiteLeerlauf; override;
        destructor gibFrei; override;

   end;

implementation

//+---------------------------------------------------------------------
//|         TMuehlenAnwendung: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TMuehlenAnwendung.init;
begin
  inherited init;
  dieUhr        := Uhr.init;
  KSchneller    := TKreisknopf.init(100,400,10,'+',dieMaus);
  KStop         := TKreisknopf.init(150,400,10,'|||',dieMaus);
  KLangsamer    := TKreisknopf.init(200,400,10,'-',dieMaus);
  KneueMuehle   := TRechteckknopf.init(300,400,100,'NEUE MHLE',dieMaus);

  KEnde.HaengeAn(KSchneller);
  KEnde.HaengeAn(KStop);
  KEnde.HaengeAn(KLangsamer);
  KEnde.HaengeAn(KneueMuehle);

   KSchneller.aktiviere;
   KLangsamer.aktiviere;
   KStop.aktiviere;
   KneueMuehle.aktiviere;

  Muehle1       := TMuehle.init(150,300,150,3,rot);
  neueMuehle    := TMuehle.init(300,200,120,2,blau);
  Muehle1.haengeAn(neueMuehle);
end;

//-------- bearbeiteLeerlauf (public) ----------------------------------
procedure TMuehlenAnwendung.bearbeiteLeerlauf;
begin
   muehle1.drehe;
   dieUhr.warte(1)
end;

//-------- gibFrei (public) --------------------------------------------
destructor TMuehlenAnwendung.gibFrei;
begin
  KSchneller.GibFrei;
  KStop.GibFrei;
  KLangsamer.GibFrei;
  KEnde.GibFrei;
  KneueMuehle.GibFrei;
  Muehle1.GibFrei;
  inherited gibFrei
end;

end.
