UNIT mTRechteckKnopf;

interface

uses          mSuM, mTEreignisKnopf;
// Uses-Klausel ggf. anpassen

type
   TRechteckKnopf = CLASS(TEreignisKnopf)

     // weitere Methoden
     public
        procedure loesche; override;
        procedure zeichne; override;
        function innerhalb(pX,pY:Zahl) : Wahrheitswert; override;

   end;

implementation

//+---------------------------------------------------------------------
//|         TRechteckKnopf: Methodendefinition 
//+---------------------------------------------------------------------

//-------- loesche (public) --------------------------------------------
procedure TRechteckKnopf.loesche;
begin
   hatStift.setzefarbe(weiss);
   hatStift.setzeFuellMuster(gefuellt);
   hatStift.setzeLinienbreite(3);
   hatStift.bewegeBis(zXPos,zYPos);
   hatStift.zeichneRechteck(zGroesse,18);
end;

//-------- zeichne (public) --------------------------------------------
procedure TRechteckKnopf.zeichne;
var lokaleSchriftbreite : Ganzezahl;
begin
  hatStift.bewegeBis(zXPos,zYPos);
  hatStift.setzeLinienbreite(1);
  if zAktiv
     then
        hatStift.setzeFarbe(hellgruen)
     else
        hatStift.setzefarbe(hellgrau);
  hatStift.setzeFuellMuster(gefuellt);
  hatStift.zeichneRechteck(zGroesse,18);
  hatStift.setzeFarbe(schwarz);
  hatStift.setzeFuellMuster(durchsichtig);
  if zAktiv then
    begin
      if zWurdeGedrueckt then
         hatStift.setzeLinienbreite(3)
      else
         hatStift.setzeLinienBreite(2);
    end
  else
    begin
      hatStift.setzeLinienbreite(1)
    end;
  hatStift.zeichneRechteck(zGroesse,18);

  if zAktiv
     then
       begin
         hatStift.setzeSchriftStil(fett);
         hatStift.setzeFarbe(schwarz);
       end
     else
       begin
         hatStift.setzeSchriftstil(standardstil);
         hatStift.setzeFarbe(dunkelgrau)
       end;
  hatStift.setzeSchriftgroesse(14);
  lokaleSchriftbreite := hatStift.TextBreite(zAufschrift);
  hatStift.bewegeBis(zXPos+(zGroesse-lokaleSchriftbreite)/2,zYPos+2);
  hatStift.schreibeText(zAufschrift);
end;

//-------- innerhalb (public) ------------------------------------------
function TRechteckKnopf.innerhalb(pX,pY:Zahl) : Wahrheitswert;
begin
   result :=(pX > zXpos ) and
            (pX < zXPos + zGroesse) and
            (pY > zYPos) and
            (pY < zYPos+18)

end;

end.
